{------------------------------------------------------------------------------}
{  PDUFormat unit: a unit to convert unicode SMS message as 16 bit PDU format  }
{  By Motaz Abdel Azeem                                                        }
{  http://Code.sd                                                              }
{  License: LGPL                                                               }
{------------------------------------------------------------------------------}

unit PDUFormat;

interface

uses SysUtils;

procedure StringToPDU(TextMsg: WideString; phoneNumber,
  smscNumber: string; var ATCommand, Data: string); // AJA fixed SMSC processing

implementation

function semiOctetToString(inp: string): string; forward;

procedure StringToPDU(TextMsg: WideString; phoneNumber,
  smscNumber: string; var ATCommand, Data: string); // AJA fixed SMSC processing
var
  BitSize: Integer;
  OctetFirst, OctetSecond, Output: string;
  SMSC_INFO_LENGTH : string;
  SMSC_LENGTH : Integer;
  SMSC_NUMBER_FORMAT : string;
  SMSC : string;
  FirstOctet: string;
  REIVER_NUMBER_FORMAT: string;
  REIVER_NUMBER_LENGTH: Integer;
	PROTO_ID: string;
	DATA_ENCODING: string;
	userDataSize: string;
  i: Integer;
  Header: string;
	REIVER_NUMBER: string;
  Valid_PERIOD: string;
  MyChar: Integer;  
begin

  BitSize:= 16;

  if PhoneNumber[1] = '+' then
    Delete(PhoneNumber, 1, 1);

  if smscNumber[1] = '+' then
    Delete(smscNumber, 1, 1);
  //Make header

  	SMSC_NUMBER_FORMAT:= '91'; // International format

    if Length(smscNumber) mod 2 <> 0 then
      smscNumber:= smscNumber + 'F';

    SMSC:= semiOctetToString(smscNumber);

  	SMSC_INFO_LENGTH:= IntToStr(Length((SMSC_NUMBER_FORMAT + '' + SMSC)) div 2);

    SMSC_LENGTH:= StrToInt(SMSC_INFO_LENGTH);


  if StrToInt(SMSC_INFO_LENGTH) < 10 then
     SMSC_INFO_LENGTH:= '0' + SMSC_INFO_LENGTH;

  FirstOctet:= '1100';
	
  REIVER_NUMBER_FORMAT:= '91'; // International format

  REIVER_NUMBER_LENGTH:= Length(phoneNumber);

	if Length(phoneNumber) mod 2 <> 0 then
		phoneNumber:= PhoneNumber + 'F';

	REIVER_NUMBER:= semiOctetToString(phoneNumber);
	PROTO_ID:= '00';
	DATA_ENCODING:= '08';

	VALID_PERIOD:= 'AA';

  // 16 bit encoding 
  userDataSize := IntToHex(Length(TextMsg) * 2, 2);

  for i:= 1 to Length(TextMsg) do
  begin
    myChar:= Ord(TextMsg[i]);
    output:= output + '' + IntToHex((myChar and $ff00) shr 8, 2) +
      (IntToHex(myChar and $00ff , 2));
  end;

  Header:= SMSC_INFO_LENGTH + SMSC_NUMBER_FORMAT + SMSC + 
     firstOctet + IntToHex(REIVER_NUMBER_LENGTH, 2) + REIVER_NUMBER_FORMAT  +
     REIVER_NUMBER +  PROTO_ID + DATA_ENCODING + VALID_PERIOD +
     userDataSize;

  Data:= header + output;
	
  ATCommand := 'AT+CMGW=' + IntToStr(Length(Data) div 2 - SMSC_LENGTH - 1);
  // Add /2 for PDU length AJA - I think the SMSC information should also be excluded
	//CMGW
end;


// function to convert semioctets to a string

function semiOctetToString(inp: string): string; //sp
var
  outp: string;
  i: Integer;
  Temp: string;
begin

  for i:= 1 to Length(Inp) do
  if i mod 2 = 1 then
	begin
    temp:= Copy(inp, i, 2);
		outp := outp + temp[2] + temp[1];
  end;

  Result:= outp;
end;

end.
